require("Entities")


backfap = love.graphics.newImage("Assets/background.png")
function love.load() --  Load, load, load
	
	smallfont = love.graphics.newFont("Assets/FNT.ttf",10)	
	medium = love.graphics.newFont("Assets/Sertig.otf",25)	
	spawned = false
	gamestate = "menu"
	mapcounting = 0
	onebyone = true
	
	loadMap('/Maps/level1.lua')
end

----------------------------------------------------------------
function love.update(dt)			

	player.healthpercentage = math.floor((player.health/player.maxhealth)*100)								--Update means it Updates every frame (Too much leads to lag)
	if gamestate == "playing" then
		backMenu()
		playerMove(dt)
		updateEnemy(dt)
		bulletShoot(dt)
		bulletUpdate(dt)
		srdUPS()
		shadowMath()
		
	end

	if gamestate == "menu" then
		menuControl()
	end
	
	if gamestate == "options" then

	end
	
	if gamestate == "result" then
		playerReset()
	end
end
----------------------------------------------------------------
function love.draw()
love.graphics.scale(1.5)
 												--Draw is for graphics
	if gamestate == "playing" then
		love.graphics.setColor(255, 255, 255)
		love.graphics.draw(backfap, 0, 0)
		
		drawMap()
		playerDraw()
		bulletDraw()
		DrawEnemy()
		setSpawn()
		shadowDraw()
		guiDraw()

	end

	if gamestate == "menu" then
		menuDraw()
	end
	
	if gamestate == "options" then

	end		
	
	if gamestate == "result" then
		endScreen()
	end
end




----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
---------------------CODE YONDER--------------------------------------------------
----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
--[[
  Setups up the graphics transformation. Called internally.
--]]





function loadMap(path)
  local f = love.filesystem.load(path) -- obtain a function
  f() -- run a function
end


------------------------------------------------------------------------------
function newMap(tileW, tileH, tileSetPath, quadInfo, tileString)

  TileW = tileW
  TileH = tileH
  Tileset = love.graphics.newImage(tileSetPath)
  
  local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()

  
Quads = {}
for i,info in ipairs(quadInfo) do
  Quads[info[1]] = love.graphics.newQuad(info[2], info[3], TileW, TileH, tilesetW, tilesetH)
end

----------------------------------------------------------------------------------------
--                                      Separator                                     --
----------------------------------------------------------------------------------------
  local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight() -- Map render
  
  Quads = {}
  for _,info in ipairs(quadInfo) do
    -- info[1] = character, info[2] = x, info[3] = y
    Quads[info[1]] = love.graphics.newQuad(info[2], info[3], TileW, TileH, tilesetW, tilesetH)
  end

  TileTable = {}
  
  local width = #(tileString:match("[^\n]+"))
  
  for x = 1,width,1 do TileTable[x] = {} end

  local x,y = 1,1
  for row in tileString:gmatch("[^\n]+") do
    x = 1
    for character in row:gmatch(".") do
      TileTable[x][y] = character
      x = x + 1
    end
    y=y+1
  end
end

 
 function drawMap()
 local Tileset = love.graphics.newImage('Assets/Tileset.png')
local TileW, TileH = 20,20
local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()


  for columnIndex,column in ipairs(TileTable) do
    for rowIndex,char in ipairs(column) do
      local x,y = (columnIndex-1)*TileW, (rowIndex-1)*TileH
      love.graphics.drawq(Tileset, Quads[char], x, y)
	     if char == '#' then
        spawnX, spawnY = x, y
		end	
    end
  end
  end
  
  
  -----------------------------------------------------------------------
  ------------------------------------------------------------------------
  ------------------------------------------------------------------------
 
 function menuControl()  -- Keyboard Menu Control
   if love.keyboard.isDown("return") then
		gamestate = "playing"
   end
    if love.keyboard.isDown("o") then
		gamestate = "options"
   end
   if love.keyboard.isDown("escape") then
		love.event.push('quit')
   end
end

	heartimg = love.graphics.newImage("Assets/heart.png")
function guiDraw()
	mobcount = #enemies
	love.graphics.setFont(smallfont)
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("Pause [P]", 550, 2)
	love.graphics.print("Enemies: "..mobcount.." ", 2, 2)
	love.graphics.print("Rooms: "..mapcounting.." ", 100, 2)
	love.graphics.print("( "..math.floor(player.x/20).." , "..math.floor(player.y/20).." )", 200, 2)
	love.graphics.print("HP: "..player.healthpercentage.."%", 45, 362)
	love.graphics.print(" "..player.health.." / "..player.maxhealth, 45, 369)
	love.graphics.draw(heartimg, 2, 364)
	love.graphics.print("Energy: "..player.srcd.." / "..player.srmc, 400, 369)
end

function endScreen()
	mobcount = #enemies
	love.graphics.setFont(medium)
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("Enemies: "..mobcount.." ", 200, 200)
	love.graphics.print("Rooms Traversed: "..mapcounting.." ", 200, 220)
	love.graphics.print("Continue [N]", 200, 260)
	
end



function menuDraw()
	love.graphics.setFont(medium)
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("Play (ENTER)", 200, 160)
	love.graphics.print("Options (O)", 200, 180)
	love.graphics.print("Exit (ESC)", 200, 200)
end

function backMenu()   
   if love.keyboard.isDown("p") then
		gamestate = "menu"
   end
end


-------------------------------------------------------
-------------------------------------------------------
function setSpawn()
if spawned == false then
player.x = spawnX - 10
player.y = spawnY - 10
spawned = true
onebyone = true
end
end

player = {}
player.x = 0
player.y = 0
player.speed = 100
player.healthpercentage = 100
player.swimspeed = 50
player.maxhealth = 500
player.health = 500
player.damage = 2
player.dir = "down"
----------
player.srd = true -- Will Fire
player.srcd = 100 -- CoolDown
player.srmc = 100 -- Max CoolDown
player.srul = 100 -- Amount Energy Lost Per Fire
player.srlod = 1 -- Reload Rate
player.sreq = player.srul -- Req To Fire
player.srfp = 200
player.sdamage = 100


player.pic = love.graphics.newImage("Assets/player.png")
player.shade = love.graphics.newImage("Assets/Follower.png")

function playerDraw()
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(player.pic, player.x, player.y)
end
player.height = 19  
player.width = 19

collideTiles = {  -- This function Dictates Wall Collisions
   b = true,
   x = true,
   q = true
}
function collision(newx, newy)
   if collideTiles[ TileTable[ math.floor( newx / TileW ) + 1 ][ math.floor( newy / TileH ) + 1 ] ] or
     collideTiles[ TileTable[ math.floor( (newx + player.width) / TileW ) + 1 ][ math.floor( newy / TileH ) + 1 ] ] or
     collideTiles[ TileTable[ math.floor( newx / TileW ) + 1 ][ math.floor( (newy + player.height) / TileH ) + 1 ] ] or
     collideTiles[TileTable[math.floor((newx + player.width) / TileW)+ 1][math.floor((newy + player.height)/TileH)+ 1]] then
      return true
   end
   return false
end


slowTiles = { -- This Function Dictates Slow Tiles
   A = true,
   B = true,
   C = true,
   D = true,
   E = true,
   F = true,
   G = true,
   H = true,
   I = true
}
function tileSlow(snewx, snewy)
   if slowTiles[ TileTable[ math.floor( snewx / TileW ) + 1 ][ math.floor( snewy / TileH ) + 1 ] ] or
     slowTiles[ TileTable[ math.floor( (snewx + player.width) / TileW ) + 1 ][ math.floor( snewy / TileH ) + 1 ] ] or
     slowTiles[ TileTable[ math.floor( snewx / TileW ) + 1 ][ math.floor( (snewy + player.height) / TileH ) + 1 ] ] or
     slowTiles[TileTable[math.floor((snewx + player.width) / TileW)+ 1][math.floor((snewy + player.height)/TileH)+ 1]] then
      return true
   end
   return false
end

exitTiles = { -- This Function Dictates Slow Tiles
   W = true,
   X = true,
   Y = true,
   Z = true,
}
function tileExit(snewx, snewy)
   if exitTiles[ TileTable[ math.floor( xnewx / TileW ) + 1 ][ math.floor( xnewy / TileH ) + 1 ] ] or
     exitTiles[ TileTable[ math.floor( (xnewx + player.width) / TileW ) + 1 ][ math.floor( xnewy / TileH ) + 1 ] ] or
     exitTiles[ TileTable[ math.floor( xnewx / TileW ) + 1 ][ math.floor( (xnewy + player.height) / TileH ) + 1 ] ] or
     exitTiles[TileTable[math.floor((xnewx + player.width) / TileW)+ 1][math.floor((xnewy + player.height)/TileH)+ 1]] then
      return true
   end
   return false
end

function playerMove(dt)
	healthMaintnance()

   newx, newy = player.x, player.y
   snewx, snewy = player.x, player.y
   xnewx, xnewy = player.x, player.y
   
   if love.keyboard.isDown("right") then
      newx = newx + player.speed * dt
	  player.dir = "right"
   end
   
   if love.keyboard.isDown("left") then
      newx = newx - player.speed * dt
	  player.dir = "left"
   end

   if love.keyboard.isDown("up") then
      newy = newy - player.speed * dt
	  player.dir = "up"
   end
   
   if love.keyboard.isDown("down") then
      newy = newy + player.speed * dt
	  player.dir = "down"
   end
   
   if tileSlow(snewx, player.y) then -- SlowTile Check
		player.speed = player.swimspeed
	end
	if not tileSlow(snewx, player.y) then
	player.speed = 100
   end
   
   if tileSlow(player.x, snewy) then -- SlowTile Check
		player.speed = player.swimspeed
	end
	if not tileSlow(player.x, snewy) then
	player.speed = 100
   end
   
   if not collision(newx, player.y) then --Wall Check
      player.x = newx
	  player.srcd = math.ceil(player.srcd + player.srlod * dt)
   end
   if not collision(player.x, newy) then --Wall Check
      player.y = newy
	  player.srcd = math.ceil(player.srcd + player.srlod * dt)
   end
   
   if tileExit(xnewx, player.y) then-- ExitTile Check
		if onebyone == true then 
		getNextMap()
		onebyone = false
		end
	end
   
   if tileExit(player.x, xnewy) then -- ExitTile Check
	if onebyone == true then
		getNextMap()
		onebyone = false
	end
   end
end

----------------------------------------------------------------------------------
----------------------------------------------------------------------------------

function srdUPS()
if player.srcd < player.sreq then
player.srd = false
end
if player.srcd >= player.sreq then
player.srd = true
end
if player.srcd >= player.srmc then
player.srcd = 100
end
end


------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

bullet = {}
bullet.speed = player.srfp
bullet.range = 50
function bulletSpawn(x,y,dir)
	table.insert(bullet, {width = 10, height = 10, x = x, y = y, dir = dir})
end

leftsword = love.graphics.newImage("Assets/sword_left.png")
rightsword = love.graphics.newImage("Assets/sword_right.png")
upsword = love.graphics.newImage("Assets/sword_up.png")
downsword = love.graphics.newImage("Assets/sword_down.png")


function bulletDraw()
for i, v in ipairs(bullet) do

if v.dir == 'right' then
	love.graphics.setColor(255,255,255)
	love.graphics.draw(rightsword, v.x, v.y)
end

if v.dir == 'left' then
	love.graphics.setColor(255,255,255)
	love.graphics.draw(leftsword, v.x, v.y)
end

if v.dir == 'up' then
	love.graphics.setColor(255,255,255)
	love.graphics.draw(upsword, v.x, v.y)
end

if v.dir == 'down' then
	love.graphics.setColor(255,255,255)
	love.graphics.draw(downsword, v.x, v.y)
end

end
end

function bulletUpdate(dt)
for i, v in ipairs(bullet) do
	if v.dir == 'right' then
	v.x = v.x + bullet.speed * dt
	end
	if v.dir == 'left' then
	v.x = v.x - bullet.speed * dt
	end
	if v.dir == 'up' then
	v.y = v.y - bullet.speed * dt
	end
	if v.dir == 'down' then
	v.y = v.y + bullet.speed * dt
	end
	local dx = player.x - v.x
	local dy = player.y - v.y
	local distance = math.sqrt(dx*dx+dy*dy)
	
	if distance >= bullet.range then
	table.remove(bullet, i)
	end
	
	end
end

function bulletShoot(dt)
	if love.keyboard.isDown('d') and not love.keyboard.isDown('a') and not love.keyboard.isDown('s') and not love.keyboard.isDown('w') then
		if player.srd == true then
		bulletSpawn(player.x + player.width, player. y + player.height / 2 - 10, 'right')
		player.srcd = player.srcd - player.srul
		end
	end
	if love.keyboard.isDown('a') and not love.keyboard.isDown('d') and not love.keyboard.isDown('s') and not love.keyboard.isDown('w') then
		if player.srd == true then
		bulletSpawn(player.x - player.width, player. y + player.height / 2 - 10, 'left')
		player.srcd = player.srcd - player.srul
		end
	end
	if love.keyboard.isDown('w') and not love.keyboard.isDown('a') and not love.keyboard.isDown('s') and not love.keyboard.isDown('d') then
		if player.srd == true then
		bulletSpawn(player.x + player.width / 2 - 10, player. y - player.height, 'up')
		player.srcd = player.srcd - player.srul
		end
	end
	if love.keyboard.isDown('s') and not love.keyboard.isDown('a') and not love.keyboard.isDown('d') and not love.keyboard.isDown('w') then
	if player.srd == true then
		bulletSpawn(player.x + player.width / 2 - 10, player. y + player.height, 'down')
		player.srcd = player.srcd - player.srul
	end
	end
end

---------------------------------------------------------------------------------
---------------------------------------------------------------------------------

function getNextMap()
local mapCount = 5
local mapNext = math.random(2,mapCount)
nextMap = mapNext
spawned = false
loadMap('/Maps/level'..nextMap..'.lua')
end


function shadowMath()
local shadeW, shadeH = player.shade:getWidth(), player.shade:getHeight()

shadexorigin = shadeW/2
shadeyorigin = shadeH/2

shadex = (player.x - shadexorigin) + 10
shadey = (player.y - shadexorigin) + 10

end

function shadowDraw()
	love.graphics.draw(player.shade,shadex ,shadey )
end


------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------